# -*- coding: utf-8 -*-
import es
import hashlib
import datetime
import os
# import langlib # No translations implemented yet. But I'll keep it in mind.
import cmdlib
from configobj import ConfigObj
# import random
import gamethread
import popuplib
import re
import services
import cPickle
import threading
import installlib


##### TODO (Notes for the Developer) ##### 

# Bansaver would be very usefull when using this Addon. So maybe provide an configurable auto installer for bansaver? -- Complete (v3.1.1)

# What about adding a help command for admins which describes the exact use of the kick/ban commands?

# Also add a command which allows Mainadmins to delete some (old) reasons from the database?

# What about saving Database(s) on unload()? -- Complete (v3.1.1) Additional: Save the database with threading on unload()

# Multiple Languages compatible?


#####


info = es.AddonInfo()
info.name = "ChatAdmin"
info.version = "3.1.2"
info.author = "Brainsucker"
info.description = "Allows Admins to Kick or Ban Players by Chat or Consolecommand!"
info.url = "http://addons.eventscripts.com/addons/view/Chatadmin"

gamedir = str(es.ServerVar("eventscripts_gamedir")).replace("\\", os.sep)
addonpath = es.getAddonPath("chatadmin").replace("\\", os.sep)
logfile_path = os.path.join(addonpath, 'adminlog.txt')
admin_data_path = os.path.join(addonpath, 'admin_data.db')
configpath = os.path.join(addonpath, 'general_config.ini')
# lang_path = os.path.join(addonpath, 'translations.ini')


config = ConfigObj(configpath)


if not os.path.isfile(configpath):
	# Create default Config
	config['kickcmd'] = '!kick'
	config['bancmd'] = '!ban'
	config['load_message'] = 1
	config['unload_message'] = 1
	config['show_message'] = 1
	config['show_admin_name'] = 1
	config['show_reason'] = 1
	config['show_bantime'] = 1
	config['auto_update'] = 1
	config['auto_install_bansaver'] = 1
	config['default_ban_times'] = ['1h', '2h', '12h', '1d', '2d', '1w', '2w', '1m', '2m', '3m', '6m', '9m', '1y', '5y', '10y', 'perm']
	config['kick_reasons'] = ['Away from Keyboard', 'High Ping', 'Spamming the Server (Microphone)', 'Spamming the Server (Chat)', 'Spamming the Server (Teamradio)', 'Forbidden Username', 'Camping']
	config['ban_reasons'] = ['Cheat (Wallhack)', 'Cheat (Aimbot)', 'Cheat (Speedhack)', 'Cheat (Spinhack)', 'Cheat (Undefined)', 'Insulting other Players', 'Ignoring Admin commands', 'Forbidden Spraylogos', 'Misusing the Server', 'Basecamping']

	
	config.write()
	es.dbgmsg(0, '[CHATADMIN] %s' % ('*'*20))
	es.dbgmsg(0, '[CHATADMIN] Missing Configurationfile has been created.')
	es.dbgmsg(0, '[CHATADMIN] Please Configurate the following file and then reload the Addon:')
	es.dbgmsg(0, '[CHATADMIN] "%s"' % configpath)
	es.dbgmsg(0, '[CHATADMIN] %s' % ('*'*20))
	


kcmd = config["kickcmd"]
bcmd = config["bancmd"]
lm = int(config["load_message"])
unlm = int(config["unload_message"])
sm = int(config["show_message"])
san = int(config["show_admin_name"])
sr = int(config['show_reason'])
bt = int(config['show_bantime'])
au = int(config['auto_update'])
aib = int(config['auto_install_bansaver'])
dbt = config['default_ban_times']
dkr = config['kick_reasons']
dbr = config['ban_reasons']

time_to_kick = 5


# 1 = show reasons of all Admins, 2 = Show only reasons from the admin which used the command
reason_show_type = 1

# Thx to Superdave
# resid = re.compile(r'^STEAM\_0\:\d\:\d{6,8}$')

no_switch = []

left_players = {}

save_dict = {}
admin_data = {}

def timedelta_to_minutes(td):
	""" datetime.timedelta -> tuple (2) """
	time_in_seconds = td.seconds + (td.days * 86400)
	time_in_minutes = float(time_in_seconds)/float(60)
	return (time_in_seconds, time_in_minutes)

year_td = datetime.timedelta(days=365)
year_td_min = timedelta_to_minutes(year_td)[1]

month_td = year_td / 12
month_td_min = timedelta_to_minutes(month_td)[1]

day_td = datetime.timedelta(days=1)
day_td_min = timedelta_to_minutes(day_td)[1]

week_td = day_td * 7
week_td_min = timedelta_to_minutes(week_td)[1]

hour_td = datetime.timedelta(hours=1)
hour_td_min = timedelta_to_minutes(hour_td)[1]

minute_td = datetime.timedelta(minutes=1)

popup_names = []


try:
	admin_data = cPickle.load(open(admin_data_path, 'rb'))
except:
	pass
	

def updater():
	addon_installer = installlib.getInstaller('ChatAdmin')
	es.dbgmsg(1, '[CHATADMIN] Checking for Updates...')
	if not addon_installer.isInstalled():
		# It seems the Addon has not been installed correctly. So we will run the install() function once again to provide correct installation.
		addon_installer.install()
		
	aia = addon_installer.addon
		
	new_version = aia.currentversion
	
	installinfo = aia.infomanager.getInstallInfo(aia.basename)
	installed_version = installinfo.getVersion()
	
	if au:
		update_status = addon_installer.update()
		if update_status == addon_installer.STATUS_SUCCESSFUL:
			update_text = '[CHATADMIN] has been successfully Updated to Version %s' % new_version
			es.log(update_text)
			es.dbgmsg(0, update_text)
			es.reload('chatadmin')
			
		elif update_status == addon_installer.STATUS_ALREADY_DONE:
			es.dbgmsg(0, '[CHATADMIN] Addon is up to date.')
			
		else:
			errormessage = update_status
			if update_status == addon_installer.STATUS_NO_DOWNLOAD:
				errormessage = 'No Download available'
			if update_status == addon_installer.STATUS_NO_INSTALL_INFO:
				errormessage = 'No InstallInfo found'
			if update_status == addon_installer.STATUS_NOT_APPROVED:
				errormessage = 'Addon is not approved'
				
			error_txt = '[CHATADMIN] Failed to Update! Please contact the developer. Error: %s' % errormessage
			es.dbgmsg(0, error_txt)
			es.log(error_txt)
			
	else:
		# Even if auto update is disabled, we will inform the User about Updates.
		if new_version != installed_version:
			es.dbgmsg(0, '[CHATADMIN] Update availabe (v%s). But AutoUpdate is disabled. Please install the update manually or enable AutoUpdate.' % new_version)

def load():

	global auth_service
	if hashlib.md5(info.author).hexdigest() == "e23f4403f295a005453317e0808f8f40":
		if services.isRegistered("auth"):
			auth_service = services.use("auth")
			auth_service.registerCapability("chatadmin_kick", auth_service.ADMIN)
			auth_service.registerCapability("chatadmin_ban", auth_service.ADMIN)
			auth_service.registerCapability('chatadmin_offlineban', auth_service.ADMIN)
			auth_service.registerCapability('chatadmin_save_reasons', auth_service.ADMIN)
			auth_service.registerCapability('chatadmin_save_bantimes', auth_service.ADMIN)
			# auth_service.registerCapability('chatadmin_delete_reasons', auth_service.ROOT)
			# auth_service.registerCapability('chatadmin_warnplayer', auth_service.ADMIN)
			# auth_service.registerCapability('chatadmin_showpunish', auth_service.POWERUSER)
			es.ServerVar(info.name, info.version).makepublic()
			
			if es.exists("saycommand", kcmd):
				cmdlib.unregisterSayCommand(kcmd)
			cmdlib.registerSayCommand(kcmd, fastkick, "Command for Admins to kick a player by chat")
			
			if es.exists("saycommand", bcmd):
				cmdlib.unregisterSayCommand(bcmd)
			cmdlib.registerSayCommand(bcmd, fastban, "Command for Admins to ban players by chat")
			
			if es.exists("clientcommand", kcmd):
				cmdlib.unregisterClientCommand(kcmd)
			cmdlib.registerClientCommand(kcmd, fastkick, "Command for Admins to kick players by console")
			
			if es.exists("clientcommand", bcmd):
				cmdlib.unregisterClientCommand(bcmd)
			cmdlib.registerClientCommand(bcmd, fastban, "Command for Admins to ban players by console")
			
			updater()
			
			if aib:
				bs = installlib.getInstaller('bansaver')
				if not bs.isInstalled():
					es.dbgmsg(0, '[CHATADMIN] Bansaver was not found on your system and will be installed now.')
					bss = bs.install(True)
					if bss == bs.STATUS_SUCCESSFUL:
						es.dbgmsg(0, '[CHATADMIN] Bansaver has been installed successfully.')
						es.load('bansaver')
			
			
		
			if lm:
				es.msg("#multi", "#default[#green%s#default] has been loaded..." % info.name)
				
		else:
			es.dbgmsg(0, "[CHATADMIN] No AuthService has been found! Unloading...")
			es.unload("chatadmin")
			
def save_admin_data():
	f = open(admin_data_path, 'wb')
	threading.Thread(target=cPickle.dump, args=(admin_data, f)).start()
			
def getSteamIDList():
	sidlist = []
	for player in es.getUseridList():
		sidlist.append(es.getplayersteamid(player))
	return sidlist
	
def isfloat(text):
	try:
		float(text)
	except:
		return False
	else:
		return True
	return False
	
def convertbantime(textstring):
	""" str -> datetime.timedelta (1) """
	tmpbantime = datetime.timedelta()
	tsl = textstring.lower()
	#Thx to Superdave
	r = re.compile('(\d+)([a-zA-Z]+)')
	bdict = dict((y, x) for x, y in r.findall(tsl))
	success = False
	
	if tsl in ('perm', 'permanent'):
		success = True

	else:
		if bdict.has_key("y"):
			if bdict["y"].isdigit():
				tmpbantime += year_td * int(bdict["y"])
				success = True
		if bdict.has_key("m"):
			if bdict["m"].isdigit():
				tmpbantime += month_td * int(bdict['m'])
				success = True
		if bdict.has_key("w"):
			if bdict["w"].isdigit():
				tmpbantime += week_td * int(bdict["w"])
				success = True
		if bdict.has_key("d"):
			if bdict["d"].isdigit():
				tmpbantime += day_td * int(bdict["d"])
				success = True
		if bdict.has_key("h"):
			if bdict["h"].isdigit():
				tmpbantime += hour_td * int(bdict["h"])
				success = True
			
	return (success, tmpbantime)
			
def getTimeText(time_in_minutes):
	""" int -> str (3) """
	if time_in_minutes == 0:
		return 'PERMANENT'

	text_list = []
	year_tuple = divmod(time_in_minutes, year_td_min)
	years = year_tuple[0]
	if years > 0:
		text_list.append("%i Year(s)" % years)
	month_tuple = divmod(year_tuple[1], month_td_min)
	months = month_tuple[0]
	if months > 0:
		text_list.append("%i Month(s)" % months)
	week_tuple = divmod(month_tuple[1], week_td_min)
	weeks = week_tuple[0]
	if weeks > 0:
		text_list.append("%i Week(s)" % weeks)
	day_tuple = divmod(week_tuple[1], day_td_min)
	days = day_tuple[0]
	if days > 0:
		text_list.append("%i Day(s)" % days)
	hour_tuple = divmod(day_tuple[1], hour_td_min)
	hours = hour_tuple[0]
	if hours > 0:
		text_list.append("%i Hour(s)" % hours)
	minutes = hour_tuple[1]
	if minutes > 0:
		text_list.append("%i Minute(s)" % minutes)
		
	full_ban_text = ", ".join(text_list)
			
	return full_ban_text
	
def processPunish(userid):
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	td = datetime.datetime.today()
	td_ctime = td.ctime()
	for psteamid in save_dict[steamid]["chosen"]:
		on_server = False
		x = None
		pname = "Unknown"
		if psteamid in getSteamIDList():
			on_server = True
			x = es.getuserid(psteamid)
			pname = es.getplayername(x)
		if not on_server:
			if left_players.has_key(psteamid):
				pname = left_players[psteamid]['lastname']
				
		m = ', '.join(save_dict[steamid]["reason"])
			
				
		if save_dict[steamid]["type"] == "kick":
			if on_server:
				log(name, steamid, pname, psteamid, save_dict[steamid]["type"], m, None, on_server)
				es.tell(x, "********************")
				es.tell(x, "You have been kicked by an Admin.")
				es.tell(x, "Adminname: %s" % name)
				es.tell(x, "Reason for kick: %s" % m)
				es.tell(x, "Servertime: %s" % td_ctime)
				es.tell(x, "********************")
				gamethread.delayed(0.5, es.server.queuecmd, "kickid %s Kicked by Admin" % x)
				if sm:
					es.msg("#multi", "#default[ADMIN%s] Kicked Player #green%s#default.%s" % ((" #green%s#default" % name) if san else "", pname, (' Reason: #green%s#default.' % m) if sr else ''))
					
		elif save_dict[steamid]["type"] == "ban":
			bt_converted = timedelta_to_minutes(save_dict[steamid]["bantime"])
			bantime_minutes = bt_converted[1]
			if on_server:
				es.server.queuecmd("es_xchangeteam %s 1" % x)
				no_switch.append(psteamid)
				
				for y in xrange(time_to_kick):
					gamethread.delayed(y, es.tell, (x, "#multi", "#greenPlease check your console for details! #defaultDisconnect in %i Seconds" % (time_to_kick-y)))
				gamethread.delayed(time_to_kick, es.server.queuecmd, ("kickid %s Banned by Admin" % x))
				
				expire_date = td + save_dict[steamid]["bantime"]
				
				bantime_text = getTimeText(bantime_minutes)
				
				es.tell(x, "#multi" ,"#default********************")
				es.tell(x, "#multi", "#defaultYou have been banned by an Admin.")
				es.tell(x, "#multi", "#defaultAdminname: %s" % name)
				es.tell(x, "#multi", "#defaultBantime: %s" % bantime_text)
				es.tell(x, "#multi", "#defaultReason for ban: %s" % m)
				es.tell(x, "#multi", "#defaultServertime: %s" % td_ctime)
				es.tell(x, "#multi", "#defaultExpiredate: %s" % expire_date.ctime())
				es.tell(x, "#multi", "#default********************")
				if sm:
					es.msg("#multi", "#default[ADMIN%s] Banned Player #green%s#default.%s%s" % ((" #green%s#default" % name) if san else "", pname, (' Bantime: #green%s#default.' % bantime_text) if bt else '', (' Reason: #green%s#default.' % m) if sr else ''))
			else:
				es.tell(userid, "#multi", "#defaultSuccessfully banned STEAMID #green%s #defaultwith reason #green%s" % (psteamid, m))
				
			log(name, steamid, pname, psteamid, save_dict[steamid]["type"], m, save_dict[steamid]["bantime"], on_server)
			
			es.server.queuecmd("banid %s %s" % (bantime_minutes, psteamid))
			
			if bantime_minutes == 0:
				es.server.queuecmd("writeid")
				
def reasons_select(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	
	if choice == 'continue':
		choosePlayers(userid)
	
	else:
		if choice in save_dict[steamid]['reason']:
			save_dict[steamid]['reason'].remove(choice)
			
		else:
			save_dict[steamid]['reason'].append(choice)
			
		sendReasons(userid)
	
	
def sendReasons(userid):
	steamid = es.getplayersteamid(userid)
	
	if not popup_names.count('chatadmin_reasons'):
		popup_names.append('chatadmin_reasons')
	
	
	if popuplib.exists('chatadmin_reasons'):
		popuplib.delete('chatadmin_reasons')
			
	car = popuplib.easymenu('chatadmin_reasons', None, reasons_select)
	car.settitle('Choose the reason(s) you want to use:')
		
	if len(save_dict[steamid]['reason']) > 0:
		car.addoption('continue', 'Continue')
	
	if save_dict[steamid]['type'] == 'kick':
		for kreason in dkr:
			car.addoption(kreason, ('* ' if kreason in save_dict[steamid]['reason'] else '') + kreason)
			
	elif save_dict[steamid]['type'] == 'ban':
		for breason in dbr:
			car.addoption(breason, ('* ' if breason in save_dict[steamid]['reason'] else '') + breason)
			
	if reason_show_type == 1:
		for ad in admin_data.keys():
			if save_dict[steamid]['type'] == 'kick':
				if admin_data[ad].has_key('kickreasons'):
					for kr in admin_data[ad]['kickreasons']:
						car.addoption(kr, ('* ' if kr in save_dict[steamid]['reason'] else '') + kr)
			if save_dict[steamid]['type'] == 'ban':
				if admin_data[ad].has_key('banreasons'):
					for br in admin_data[ad]['banreasons']:
						car.addoption(br, ('* ' if br in save_dict[steamid]['reason'] else '') + br)
				
	elif reason_show_type == 2:
		if admin_data.has_key(steamid):
			if save_dict[steamid]['type'] == 'kick':
				if admin_data[ad].has_key('kickreasons'):
					for kr in admin_data[steamid]['kickreasons']:
						car.addoption(kr, ('* ' if kr in save_dict[steamid]['reason'] else '') + kr)
					
			if save_dict[steamid]['type'] == 'ban':
				if admin_data[ad].has_key('banreasons'):
					for br in admin_data[steamid]['banreasons']:
						car.addoption(br, ('* ' if br in save_dict[steamid]['reason'] else '') + br)
				
	car.send(userid)
	
				
def ask_reasons_select(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	
	if choice == 'yes':
		sendReasons(userid)
			
			
	elif choice == 'no':
		save_dict[steamid]['reason'] = ['Not specified']
		choosePlayers(userid)
				
def showReasons(userid):
	steamid = es.getplayersteamid(userid)
	
	if not popup_names.count('chatadmin_ask_reasons'):
		popup_names.append('chatadmin_ask_reasons')
	
	if popuplib.exists('chatadmin_ask_reasons'):
		popuplib.delete('chatadmin_ask_reasons')
	
	caar = popuplib.easymenu('chatadmin_ask_reasons', None, ask_reasons_select)
	caar.settitle('You have no reason specified.\nDo you want to select an old reason?')
	caar.addoption('yes', 'Yes')
	caar.addoption('no', 'No')
	
	caar.send(userid)
				
def left_players_select(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice == 'execute':
		processPunish(userid)
		
	elif choice == 'go_back':
		choosePlayers(userid)
		
		
	else:
		if choice in save_dict[steamid]['chosen']:
			save_dict[steamid]['chosen'].remove(choice)
		else:
			save_dict[steamid]['chosen'].append(choice)
			
		showLeftPlayers(userid)

		
def showLeftPlayers(userid):
	steamid = es.getplayersteamid(userid)
	
	if not popup_names.count('chatadmin_leftplayers'):
		popup_names.append('chatadmin_leftplayers')
	
	if popuplib.exists('chatadmin_leftplayers'):
		popuplib.delete('chatadmin_leftplayers')

	lp = popuplib.easymenu('chatadmin_leftplayers', None, left_players_select)
	lp.settitle('Choose the Players you want to ban:')
	if len(save_dict[steamid]['chosen']) > 0:
		lp.addoption('execute', 'Ban them!')
	else:
		lp.addoption('go_back', 'Back to current Players')
		

	for x in sorted(left_players.items(), key=lambda m: m[1]['leave_time'], reverse=True):
		pl_sid = x[0]
		pl_data = left_players[pl_sid]
		lp.addoption(pl_sid, ('* ' if pl_sid in save_dict[steamid]['chosen'] else '') + pl_data['lastname'])
		
	lp.send(userid)
				
def popup_choice(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice == "execute":
		processPunish(userid)
					
					
	elif choice == 'left_player':
		showLeftPlayers(userid)
					
	else:
		if choice in save_dict[steamid]["chosen"]:
			save_dict[steamid]["chosen"].remove(choice)
		else:
			save_dict[steamid]["chosen"].append(choice)
			
		choosePlayers(userid)
		
def choosePlayers(userid):
	steamid = es.getplayersteamid(userid)
	
	if not popup_names.count('chatadmin_playerpopup'):
		popup_names.append('chatadmin_playerpopup')
	
	if popuplib.exists("chatadmin_playerpopup"):
		popuplib.delete("chatadmin_playerpopup")
	capp = popuplib.easymenu("chatadmin_playerpopup", None, popup_choice)
	capp.settitle("Choose the Players you want to %s\nwith the reason(s): %s" % (save_dict[steamid]["type"], ', '.join(save_dict[steamid]["reason"])))
	if len(save_dict[steamid]["chosen"]):
		capp.addoption("execute", "%s them!" % save_dict[steamid]["type"].capitalize())
	else:
		if save_dict[steamid]["type"] == 'ban':
			if auth_service.isIdAuthorized(steamid, 'chatadmin_offlineban'):
				capp.addoption('left_player', 'Ban left Player(s)')
	for player in es.getUseridList():
		if not es.isbot(player):
			sid = es.getplayersteamid(player)
			capp.addoption(sid, ("* " if sid in save_dict[steamid]["chosen"] else "") + es.getplayername(player))
	capp.send(userid)
	
def bantime_choice(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	
	if choice == 'continue':
		if len(save_dict[steamid]["reason"]) == 0:
			showReasons(userid)
		else:
			choosePlayers(userid)
			
	else:
		save_dict[steamid]["bantime"] = choice
		showBanTimes(userid)
	
def showBanTimes(userid):
	steamid = es.getplayersteamid(userid)
	
	if not popup_names.count('chatadmin_bantimes'):
		popup_names.append('chatadmin_bantimes')
		
	if popuplib.exists('chatadmin_bantimes'):
		popuplib.delete('chatadmin_bantimes')
		
	cabt = popuplib.easymenu('chatadmin_bantimes', None, bantime_choice)
	if save_dict[steamid].has_key('bantime'):
		cabt.settitle('Choose the Bantime:\nCurrent Bantime: %s' % getTimeText(timedelta_to_minutes(save_dict[steamid]['bantime'])[1]))
		cabt.addoption('continue', 'Continue')
	else:
		cabt.settitle('Choose the Bantime:')
	
	all_bantimes = {}
	for x in dbt:
		success, bantime_td = convertbantime(x)
		if success:
			td_min = timedelta_to_minutes(bantime_td)[1]
			if not all_bantimes.has_key(td_min):
				all_bantimes[td_min] = bantime_td
	if admin_data.has_key(steamid):
		if admin_data[steamid].has_key('bantimes_used'):
			for y in admin_data[steamid]['bantimes_used']:
				success, bantime_td = convertbantime(y)
				if success:
					td_min = timedelta_to_minutes(bantime_td)[1]
					if not all_bantimes.has_key(td_min):
						all_bantimes[td_min] = bantime_td
				
	sorted_bantimes = sorted(all_bantimes.keys())
		
	for bt in sorted_bantimes:
		bt_td = all_bantimes[bt]
		bt_text = getTimeText(bt)
		add_line = True
		if save_dict[steamid].has_key('bantime'):
			if bt_td == save_dict[steamid]['bantime']:
				add_line = False
				cabt.addoption(bt_td, '* ' + bt_text)
		if add_line:
			cabt.addoption(bt_td, bt_text)
		
	
	
	cabt.send(userid)


def fastkick(userid, args):
	if len(args) > 0:
		args = str(args).split()
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	if auth_service.isIdAuthorized(steamid, "chatadmin_kick"):
		save_dict[steamid] = {}
		save_dict[steamid]["type"] = "kick"
		save_dict[steamid]["chosen"] = []
		save_dict[steamid]["reason"] = []
		

		kickreason = None
		if len(args) > 0:
			kickreason = " ".join(args)
			if auth_service.isIdAuthorized(steamid, 'chatadmin_save_reasons'):
				if not admin_data.has_key(steamid):
					admin_data[steamid] = {}
				if not admin_data[steamid].has_key('kickreasons'):
					admin_data[steamid]['kickreasons'] = []
				if not kickreason in admin_data[steamid]['kickreasons']:
					admin_data[steamid]['kickreasons'].append(kickreason)
					save_admin_data()
			save_dict[steamid]["reason"].append(kickreason)
			choosePlayers(userid)
			
		if not kickreason:
			showReasons(userid)
		
	else:
		es.tell(userid, '#multi', '#defaultYou are not authorized to use this command')

def fastban(userid, args):
	if len(args) > 0:
		args = str(args).split()
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	save_data = False
	if auth_service.isIdAuthorized(steamid, "chatadmin_ban"):
		save_dict[steamid] = {}
		save_dict[steamid]["type"] = "ban"
		save_dict[steamid]["chosen"] = []
		save_dict[steamid]["reason"] = []
		
		
		if len(args) > 0:
			arg1 = str(args[0])
			arg1l = arg1.lower()
			if arg1.isdigit():
				bantime = minute_td * int(arg1)
				save_dict[steamid]["bantime"] = bantime

			else:
				success, bantime = convertbantime(arg1)
				if success:
					save_dict[steamid]["bantime"] = bantime
					if auth_service.isIdAuthorized(steamid, 'chatadmin_save_bantimes'):
						if not admin_data.has_key(steamid):
							admin_data[steamid] = {}
						if not admin_data[steamid].has_key('bantimes_used'):
							admin_data[steamid]['bantimes_used'] = []
						if not arg1 in admin_data[steamid]['bantimes_used']:
							admin_data[steamid]['bantimes_used'].append(arg1)
							save_data = True
							
					if len(args) > 1: # Currently there is only the option to add a reason when you specified a bantime. Sorry :(
						banreason = " ".join(args).split(" ", 1)[1]
						if banreason:
							if auth_service.isIdAuthorized(steamid, 'chatadmin_save_reasons'):
								if not admin_data[steamid].has_key('banreasons'):
									admin_data[steamid]['banreasons'] = []
								if not banreason in admin_data[steamid]['banreasons']:
									admin_data[steamid]['banreasons'].append(banreason)
									save_data = True
									
							save_dict[steamid]["reason"].append(banreason)
							choosePlayers(userid)
						else:
							showReasons(userid)
							
					else:
						showReasons(userid)
					
				else:
					showBanTimes(userid)
					

					
		else:
			showBanTimes(userid)
			
	else:
		es.tell(userid, '#multi', '#defaultYou are not authorized to use this command')
		
	if save_data:
		save_admin_data()

def unload():
	if es.exists('saycommand', kcmd):
		cmdlib.unregisterSayCommand(kcmd)
	if es.exists('saycommand', bcmd):
		cmdlib.unregisterSayCommand(bcmd)
	if es.exists('clientcommand', kcmd):
		cmdlib.unregisterClientCommand(kcmd)
	if es.exists('clientcommand', bcmd):
		cmdlib.unregisterClientCommand(bcmd)
		
	for pn in popup_names:
		if popuplib.exists(pn):
			popuplib.delete(pn)
			
			
	f = open(admin_data_path, 'wb')
	cPickle.dump(admin_data, f)
			
		
	if unlm:
		es.msg("#multi", "#default[#green%s#default] has been unloaded..." % info.name)


def exists(a, b):
	uidlist = es.getUseridList()
	if a == "playername":
		for player in uidlist:
			if b == es.getplayername(player):
				return True

	elif a == "userid":
		return (int(b) in uidlist)

	elif a == "steamid":
		return (b in getSteamIDList())
		
	return False 

def checkuserid(argument):
	if str(argument).isdigit():
		if exists("userid", int(argument)):
			return argument

	if exists("steamid", argument):
		return es.getuserid(argument)

	if exists("playername", argument):
		return es.getuserid(argument)

	return False

def log(adminname, adminsteamid, username, usersteamid, punishtype, reason=None, bantime=None, on_server=True):
	logfile = open(logfile_path, "ab")
	td = datetime.datetime.today()
	
	logfile.write('\n\n-----\n')
	
	if punishtype == "kick":
		logfile.write("Kicked:")

	elif punishtype == "ban":
		logfile.write("Banned:")

	logfile.write("\nDate/Time: %s\n\nAdmin:\nName: %s\nSTEAMID: %s\n\nUser:\nName: %s\nSTEAMID: %s" % (td.ctime(), adminname, adminsteamid, username, usersteamid))

	if bantime != None:
		expire_date = td + bantime
		logfile.write("\nBantime: %s" % getTimeText(timedelta_to_minutes(bantime)[1]))
		logfile.write('\nExpiry Date: %s' % expire_date.ctime())

	if reason:
		logfile.write("\n\nReason: %s" % reason)
		
	if not on_server:
		logfile.write('\nNotes:\nOffline Ban')

	logfile.write("\n-----")
		
	logfile.flush()
	logfile.close()
	
def player_team(ev):
	steamid = ev["es_steamid"]
	userid = ev["userid"]
	if steamid in no_switch:
		if ev["newteam"] != "1":
			es.server.queuecmd("es_xchangeteam %s 1" % userid)
			
def player_disconnect(ev):
	steamid = ev["networkid"]
	td = datetime.datetime.today()
	if steamid in no_switch:
		no_switch.remove(steamid)
	if not left_players.has_key(steamid):
		left_players[steamid] = {}
		
	left_players[steamid]['lastname'] = ev['name']
	left_players[steamid]['leave_time'] = td
	
def es_player_validated(ev):
	steamid = ev['networkid']
	if left_players.has_key(steamid):
		del left_players[steamid]
		
def es_map_start(ev):
	updater()